﻿using Microsoft.Extensions.DependencyInjection;
using PXPlus.Core.IntegrationEventLogEf.Services;
using PXPlus.Payment.Domain.DomainServices.Interface;
using PXPlus.Payment.Domain.Factories.Interface;

namespace PXPlus.Payment.IntegrationTest.MockServices
{
    public static class Register
    {
        public static IServiceCollection RegisterMockService(this IServiceCollection services)
            => services
                .AddSingleton<IPaymentQuotaDomainService,PaymentQuotaMockDomainService>()
                .AddSingleton<IMerchantDomainService,MerchantMockDomainService>()
                .AddSingleton<IExecutePaymentDomainServiceFactory,ExecutePaymentDomainServiceMockFactory>()
                .AddSingleton<IPayToolDomainService,PayToolMockDomainService>()
                .AddSingleton<IPointDomainService,PointMockDomainService>()
                .AddSingleton<IIntegrationEventService,IntegrationEventMockService>();
    }
}