# Integration Event

# Overview

<!-- TOC -->
- [1. PaymentService](#1-PaymentService)
    - [1.1. 付款成功](#11-付款成功) 
    - [1.2. 付款失敗](#12-付款失敗)
    - [1.3. 退款成功](#13-退款成功)
    - [1.4. 退款失敗](#14-退款失敗)
    - [1.5. 訂單回饋完成](#15-訂單回饋完成)
- [2. AccountService](#2-AccountService)
    - [2.1. 轉帳完成](#21-轉帳完成)
    - [2.2. 提領完成](#22-提領完成)
    - [2.3. 儲值完成](#23-儲值完成)
- [3. ActivityService](#3-ActivityService)
    - [3.1. 回饋完成](#31-回饋完成)
- [4. PosService](#4-PosService)
    - [4.1. 交易完成](#41-交易完成)
- [5. AppGatewayService](#5-AppGatewayService)
    - [5.1. 正掃交易完成](#51-正掃交易完成)
    - [5.2. EC正掃交易完成](#52-EC正掃交易完成)
  


<!-- /TOC -->

#1. PaymentService

## 1.1 付款成功 

**Event name:** OrderPaymentSuccessfulIntegrationEvent

**Publisher:**
Payment Service

**Publish timing:**
Order payment successful

**Subscriber:**

|Subscriber | Action|
|---|---|
|Account Service|增加付款者及收款者額度、解鎖付款者|
|Point Service|實際扣除付款者點數|
|Payment Record Service|寫入交易紀錄|
|Activity Service|給回饋|


## 1.2 付款失敗

**Event name:** OrderPaymentFailedIntegrationEvent

**Publisher:**
Payment Service

**Publish timing:**
Order payment failed

**Subscriber:**

|Subscriber | Action|
|---|---|
|Account Service|解鎖付款者|
|Point Service|返還預扣的點數|
|Activity Service|返還折抵、回饋活動資格|

## 1.3 退款成功

**Event name:** OrderRefundSuccessfulIntegrationEvent

**Publisher:**
Payment Service

**Publish timing:**
Order refund successful

**Subscriber:**

|Subscriber | Action|
|---|---|
|Todo|Todo|



## 1.4 退款失敗
**Event name:** OrderRefundFailedIntegrationEvent

**Publisher:**
Payment Service

**Publish timing:**
Order refund successful

**Subscriber:**

|Subscriber | Action|
|---|---|
|Todo|Todo|

## 1.5 訂單回饋完成
**Event name:** OrderPayBackCompletedIntegrationEvent

**Publisher:**
Payment Service

**Publish timing:**
Order pay back completed

**Subscriber:**

|Subscriber | Action|
|---|---|
|財務|記帳|





