# Payment 支付服務

UAT URIs are relative to **
Production URIs are relative to **

## Release Note
 Release Date | Note | 
 ------------ | -------------
 2021-02-26 | 初版
 2021-04-01 | 0.0.1
 2021-06-10 | 0.0.2
 2021-06-16 | 0.0.3
 2021-06-24 | 0.0.4
 


## datatime format
`yyyy-MM-dd HH:mm:ss` 時間格式format


## Documentation for API Endpoints
Method |  Description
------------- | ------------- |
[**Payment**](Payment.md#1.付款) | 付款
[**Refund**](Payment.md#2.退款) | 退款
[**Query**](Payment.md#3.查詢) | 查詢訂單結果
[**CancelPayment**](Payment.md#4.取消付款) | 取消付款
[**OrderConfirm**](Payment.md#5.訂單確認) | 訂單確認
[**CancelPaymentWithPxTradeNo**](Payment.md#6.整單取消付款) | 整單取消付款


<a name="1.付款"></a>
## 1.付款
> 執行付款並建立訂單紀錄

### Request
Name | Type | Require | Description | Notes
------------ | ------------- | ------------- | ------------- | -------------
**trade_no** | **string** | **Y** | **交易唯一碼** |For idempotency
**payer_id** | **long** | **Y** | **付款者** |
**pay_tool_type** | **int** | **Y** | **支付工具類別** | 0:Unknown 1:AccountLink 2:CreditCard 3: EPAccount
**pay_tool_seq** | **string** | **Y** |**第幾個支付工具** | 36進位 0~9 A~Z
**is_use_point** | **bool** | **Y** | **是否使用點數付款**
**store_code** | **string** | **Y** | **收款店家** |
**amount** | **double** | **Y** | **訂單金額** |
**none_feedback_amount** | **double** | **N** | **不可回饋金額** |
**none_discount_amount** | **double** | **N** | **不可折抵金額** |
**activities** | **IEnumerable Activity** | **N** | **共同行銷活動** |
**platform_type** | **int** | **N** | **全支付 = 1 ,PXPay = 2** |

#### Type


##### Activity
Name | Type | Require | Description | Notes
------------ | ------------- | ------------- | ------------- | -------------
**activity_code** | **string** | **Y** | **活動代碼** | 
**product_amount** | **double** | **Y** |**商品金額** | 


### Response
Name | Type | Require | Description | Notes
------------ | ------------- | ------------- | ------------- | -------------
**code** | **string** | **Y** |**交易結果代碼** | 0000:成功 其他:失敗
**message** | **string** | **Y** |**交易結果訊息** |
**prefix_code** | **string** | **Y** |**服務前綴碼** |
**data** | **PaymentInfo** | **Y** |**回傳資料** |


#### Type

##### PaymentInfo

Name | Type | Require | Description | Notes
------------ | ------------- | ------------- | ------------- | -------------
**px_trade_no** | **string** | **Y** |**全支付訂單號** |
**amount** | **double** | **Y** |**訂單金額** |
**trade_amount** | **double** | **Y** |**實際支付金額** |
**discount_point** | **double** | **Y** |**PX點數折抵金額** |
**pay_tool_type** | **int** | **Y** |**支付工具類別** |未知 = 0, 銀行帳戶 = 1, 信用卡 = 2, 儲值帳戶 = 3
**pay_tool_name** | **int** | **Y** |**支付工具名稱** |
**identity** | **string** | **Y** |**帳號** |
**activities** | **array ActivityDiscount** | **N** |**共同行銷活動折抵資訊** |

##### PayToolInfo
Name | Type | Require | Description | Notes
------------ | ------------- | ------------- | ------------- | -------------
**pay_tool_type** | **enum** | **Y** | **支付工具類別** | 0:Unknown 1:AccountLink 2:CreditCard 3: EPAccount
**pay_tool_name** | **string** | **Y** |**支付工具名稱** | 若支付工具為 AccountLink 或信用卡，該欄位必回覆銀行名稱若支付工具為全支付帳戶，該欄位回覆「全支付帳戶」
**identity** | **string** | **Y** | **支付工具識別碼** | 



##### ActivityDiscount
Name | Type | Require | Description | Notes
------------ | ------------- | ------------- | ------------- | -------------
**activity_code** | **string** | **Y** | **活動代碼** | 
**product_amount** | **double** | **Y** |**商品金額** | 
**discount_amount** | **double** | **Y** |**折抵金額** | 


<a name="2.退款"></a>
## 2.退款
> 執行退款並建立退款單紀錄

### Request
Name | Type | Require | Description | Notes
------------ | ------------- | ------------- | ------------- | -------------
**trade_no** | **string** | **Y** | **交易唯一碼** | 
**ori_px_trade_no** | **string** | **Y** | **全支付原訂單編號** | 
**refunder_id** | **long** | **Y** | **付款者** |
**store_code** | **string** | **Y** | **店家** |
**amount** | **double** | **Y** | **退款金額** |
**none_feedback_amount** | **double** | **N** | **不可回饋金額** |
**none_discount_amount** | **double** | **N** | **不可折抵金額** |
**activities** | **IEnumrable Activity** | **N** | **共同行銷活動** |
**cause** | **string** | **N** | **原因** |
**execute_source** | **int** | **N** | **執行來源 <br>1=pos,<br>2=取消付款排程,<br>3=商戶後台,<br>4=系統後台** |
**executor** | **string** | **N** | **執行人員** |
 
 
#### Type

##### Activity
Name | Type | Require | Description | Notes
------------ | ------------- | ------------- | ------------- | -------------
**activity_code** | **string** | **Y** | **活動代碼** | 
**product_amount** | **double** | **Y** |**商品金額** | 


### Response
Name | Type | Require | Description | Notes
------------ | ------------- | ------------- | ------------- | -------------
**code** | **string** | **Y** |**交易結果代碼** | 0000:成功 其他:失敗
**message** | **string** | **Y** |**交易結果訊息** |
**prefix_code** | **string** | **Y** |**服務前綴碼** |
**data** | **RefundInfo** | **Y** |**回傳資料** |


#### Type

##### RefundInfo
Name | Type | Require | Description | Notes
------------ | ------------- | ------------- | ------------- | -------------
**px_trade_no** | **string** | **Y** |**全支付退款訂單號** |
**amount** | **double** | **Y** |**訂單金額** |
**trade_amount** | **double** | **Y** |**實際退款金額** |
**discount_point** | **double** | **Y** |**PX點數折抵金額** |
**activities** | **array ActivityDiscount** | **N** |**共同行銷活動折抵資訊** |

##### ActivityDiscount
Name | Type | Require | Description | Notes
------------ | ------------- | ------------- | ------------- | -------------
**activity_code** | **string** | **Y** | **活動代碼** | 
**product_amount** | **double** | **Y** |**商品金額** | 
**discount_amount** | **double** | **Y** |**折抵金額** | 

<a name="3.查詢"></a>
## 3.查詢
> 查詢每筆支付/退款單交易結果
### Request
Name | Type | Require | Description | Notes
------------ | ------------- | ------------- | ------------- | -------------
**trade_no** | **string** | **Y** | **交易唯一碼** |
 

### Response
Name | Type | Require | Description | Notes
------------ | ------------- | ------------- | ------------- | -------------
**code** | **string** | **Y** |**交易結果代碼** | 0000:成功 其他:失敗
**message** | **string** | **Y** |**交易結果訊息** |
**prefix_code** | **string** | **Y** |**服務前綴碼** |
**data** | **Data** | **Y** |**回傳資料** |



#### Type

##### Data
Name | Type | Require | Description | Notes
------------ | ------------- | ------------- | ------------- | -------------
**order_type** | **int** | **Y** |**訂單類型** |0:查無訂單 1:付款訂單 2:退款訂單
**payment_info** | **PaymentInfo** | **N** |**訂單資訊** | order_type=1 有值
**refund_info** | **RefundInfo** | **N** |**退單資訊** | order_type=2 有值

<a name="4.取消付款"></a>
## 4.取消付款
> 取消付款
### Request
Name | Type | Require | Description | Notes
------------ | ------------- | ------------- | ------------- | -------------
**trade_no** | **string** | **Y** | **需要取消退款的交易唯一碼** |
**payer_id** | **int** | **Y** | **付款者** |
**store_code** | **string** | **Y** | **店家** |
**cause** | **string** | **N** | **原因** |
**execute_source** | **int** | **N** | **執行來源 <br>1=pos,<br>2=取消付款排程,<br>3=商戶後台,<br>4=系統後台** |
**executor** | **string** | **N** | **執行人員** |

### Response
Name | Type | Require | Description | Notes
------------ | ------------- | ------------- | ------------- | -------------
**code** | **string** | **Y** |**交易結果代碼** | 0000:成功 其他:失敗
**message** | **string** | **Y** |**交易結果訊息** |
**prefix_code** | **string** | **Y** |**服務前綴碼** |


<a name="5.訂單確認"></a>
## 5.訂單確認
> 訂單確認
### Request
Name | Type | Require | Description | Notes
------------ | ------------- | ------------- | ------------- | -------------
**trade_no** | **string** | **Y** | **交易唯一碼** |
**px_trade_no** | **string** | **Y** | **全支付訂單號** |
**payer_id** | **int** | **Y** | **付款者** |
**store_code** | **string** | **Y** | **店家** |


### Response

PaymentInfo


<a name="6.整單取消付款"></a>
## 6.整單取消付款
> 整單取消付款
### Request
Name | Type | Require | Description | Notes
------------ | ------------- | ------------- | ------------- | -------------
**trade_no** | **string** | **Y** | **交易唯一碼** |
**px_trade_no** | **string** | **Y** | **全支付訂單號** |
**payer_id** | **int** | **Y** | **付款者** |
**store_code** | **string** | **Y** | **店家** |
**cause** | **string** | **N** | **原因** |
**execute_source** | **int** | **N** | **執行來源 <br>1=pos,<br>2=取消付款排程,<br>3=商戶後台,<br>4=系統後台** |
**executor** | **string** | **N** | **執行人員** |

### Response
Name | Type | Require | Description | Notes
------------ | ------------- | ------------- | ------------- | -------------
**code** | **string** | **Y** |**交易結果代碼** | 0000:成功 其他:失敗
**message** | **string** | **Y** |**交易結果訊息** |
**prefix_code** | **string** | **Y** |**服務前綴碼** |
