# PaymentRecordIntegrationEvent

## PaymentRecordIntegrationEvent
-  Topic : payment_record

### Model

Name | Type | Require | Description | 
------------ | ------------- | ------------- | ------------- 
**EventType** | **int** | **Y** | **1 = Payment Service** |
**PaymentService** | **PaymentService** | **Y** | 

- PaymentService

Name | Type | Require | Description
------------ | ------------- | ------------- | ------------- 
**PaymentType** | **int** | **Y** | **1 = 付款, 2 = 退款** 
**IsSuccess** | **bool** | **Y** | **true= 成功 , false = 失敗 
**OrderPaymentSuccessfulIntegrationEvent** | **OrderPaymentSuccessfulIntegrationEvent** | **N** | **參考付款成功整合事件** 
**OrderPaymentFailedIntegrationEvent** | **OrderPaymentFailedIntegrationEvent** | **N** | **參考付款失敗整合事件** 
**OrderRefundSuccessfulIntegrationEvent** | **OrderRefundSuccessfulIntegrationEvent** | **N** | **參考退款成功整合事件** 
**OrderRefundFailedIntegrationEvent** | **OrderRefundFailedIntegrationEvent** | **N** | **參考退款失敗整合事件** 
  


class:
```c#       
public int PaymentType { get; set; }
public bool IsSuccess { get; set; }
public OrderPaymentSuccessfulIntegrationEvent OrderPaymentSuccessfulIntegrationEvent { get; set; }
public OrderPaymentFailedIntegrationEvent OrderPaymentFailedIntegrationEvent { get; set; }
public OrderRefundSuccessfulIntegrationEvent OrderRefundSuccessfulIntegrationEvent { get; set; }
public OrderRefundFailedIntegrationEvent OrderRefundFailedIntegrationEvent { get; set; }
```

Example:

付款成功
```json
{
  "EventType" :  1,
  "PaymentService": {
    "PaymentType": 1,
    "IsSuccess": true,
    "OrderPaymentSuccessfulIntegrationEvent": {
      "OrderNo": "PX202106181816465623",
      "OrderAmount": 1000,
      "PayAmount": 850,
      "PayerId": 103,
      "PayerPaymentAccount": "724711000000755",
      "PayerPayToolType": 3,
      "StoreMemberId": 144,
      "MerchantCode": "M00148",
      "MerchantName": "測試店家",
      "StoreCode": "S0000148",
      "StoreName": "全聯測試店舖",
      "StoreReceiveAccount": "EpAccount0144",
      "ActualDiscountAmount": 150,
      "TransactionTime": "2021-06-18T10:16:46.5660174Z",
      "MerchantTradeNo": "Hello12",
      "CurrencyType": "NTD",
      "PhoneNumber": "Hello123",
      "BrandName": "全聯測試店",
      "InputMetaData": {
        "Type": 0
      },
      "BankCode": "nil",
      "BankName": "nil",
      "Id": "7400f0ff-b6bd-46f7-b010-41f24758f9b7",
      "CreationDate": "2021-06-18T10:16:47.8177643Z",
      "XRequestId": "7aa23cea-eeee-41b6-b808-46411b35ccec",
      "TopicKey": "S0000148"
    }
  }
}
```

退款成功
```json
{
  "EventType" :  1,
  "PaymentService": {
    "PaymentType": 2,
    "IsSuccess": true,
    "OrderRefundSuccessfulIntegrationEvent": {
      "OrderNo": "PX202106181816465623",
      "RefundOrderNo": "PX2021061818164656230001",
      "OrderAmount": 100,
      "PayAmount": 70.00,
      "PayerId": 103,
      "MerchantCode": "M00148",
      "StoreCode": "S0000148",
      "StoreMemberId": 144,
      "ReturnDiscountPointAmount": 30.00,
      "TransactionTime": "2021-06-18T10:33:16.610232Z",
      "MerchantTradeNo": "PX202106111348493162aa",
      "RefundCause": "",
      "ExecuteSource": 0,
      "Executor": "",
      "Id": "b2921384-8808-4626-b53c-baaa9c80d33a",
      "CreationDate": "2021-06-18T10:33:16.8051436Z",
      "XRequestId": "04795030-6c88-405b-9f84-9b91bdef9e17",
      "TopicKey": "S0000148"
    }
  },
  "Id": "22974249-0316-4d2a-9cc5-fcf641187a61",
  "CreationDate": "2021-06-18T10:33:16.8076827Z",
  "XRequestId": "04795030-6c88-405b-9f84-9b91bdef9e17",
  "TopicKey": "103"
}
```


