﻿using MediatR;
using PXPlus.Payment.Application.Dto;

namespace PXPlus.Payment.Application.Commands
{
    public class CancelPaymentCommand  : IRequest<Response>
    {
        /// <summary>
        /// 原交易序號
        /// </summary>
        public string TradeNo { get; set; }
        /// <summary>
        /// 付款者
        /// </summary>
        public long PayerId { get; set; }
        /// <summary>
        /// 店家
        /// </summary>
        public string StoreCode { get; set; }
        
        public int RetryCount { get; set; }

        public string XRequestId { get; set; }
        public string RefundCause { get; set;}
        public int ExecuteSource { get; set;}
        public string Executor { get;  set;}
    }
}