using MediatR;
using PXPlus.Payment.Domain.DomainExceptions;

namespace PXPlus.Payment.Application.Commands
{
    public class IdentifiedCommand <T,TR> : IRequest<TR>
        where T : IRequest<TR>
    {
        public T Command { get; }
        /// <summary>
        /// For idempotency
        /// </summary>
        public string TradeNo { get; }

        public IdentifiedCommand(T command, string tradeNo)
        {
            if (tradeNo.Length > 60)
                throw new OrderDomainException(PaymentStatusCode.InvalidParameter);
            
            Command = command;
            TradeNo = tradeNo;
        }
    }
}