﻿using MediatR;
using PXPlus.Payment.Application.Dto;

namespace PXPlus.Payment.Application.Commands
{
    public class OrderConfirmCommand : IRequest<PaymentAppResponse>
    {
        public string PXTradeNo { get; private set; }
        public long PayerId { get; private set; }
        public string StoreCode { get; private set; }

        public OrderConfirmCommand(string pxTradeNo, long payerId, string storeCode)
        {
            PXTradeNo = pxTradeNo;
            PayerId = payerId;
            StoreCode = storeCode;
        }
    }
}