using System.Collections.Generic;
using MediatR;
using PXPlus.Enum.Authorization;
using PXPlus.Payment.Application.Dto;
using PXPlus.Payment.Domain.OrderAggregate;

namespace PXPlus.Payment.Application.Commands
{
    public class PaymentCommand : IRequest<PaymentAppResponse>
    {
        public decimal OrderAmount { get; private set; }
        public long PayerId { get; private set; }
        public string StoreCode { get; private set; }
        public int Sequence { get; private set; }
        public bool IsUsePoint { get; private set; }
        public decimal NoneFeedbackAmount { get; private set; }
        public decimal NoneDiscountAmount { get; private set; }
        public PayToolType PayToolType { get; private set; }

        public PlatformType PlatformType { get; private set; }
        public IEnumerable<ActivityCashDiscountInfo> ActivityCashDiscountInfos { get; private set; }
        public bool IsEcTrade { get;  }
        public string PhoneNumber { get;  }
        public string MerchantTradeNo { get;  }
        public MetaData InputMetaData { get; }

        public PaymentCommand(decimal orderAmount, long payerId, string storeCode, int sequence, bool isUsePoint,
            decimal noneFeedbackAmount, decimal noneDiscountAmount, PayToolType payToolType, PlatformType platformType,
            IEnumerable<ActivityCashDiscountInfo> activityCashDiscountInfos,bool isEcTrade,string phoneNumber,string merchantTradeNo
            ,MetaData inputMetaData)
        {
            OrderAmount = orderAmount;
            PayerId = payerId;
            StoreCode = storeCode;
            Sequence = sequence;
            IsUsePoint = isUsePoint;
            NoneFeedbackAmount = noneFeedbackAmount;
            NoneDiscountAmount = noneDiscountAmount;
            PayToolType = payToolType;
            PlatformType = platformType;
            ActivityCashDiscountInfos = activityCashDiscountInfos;
            IsEcTrade = isEcTrade;
            PhoneNumber = phoneNumber;
            MerchantTradeNo = merchantTradeNo;
            InputMetaData = inputMetaData;
        }
    }
}