using System.Collections.Generic;
using MediatR;
using PXPlus.Payment.Application.Dto;
using PXPlus.Payment.Domain.OrderAggregate;

namespace PXPlus.Payment.Application.Commands
{
    public class RefundCommand : IRequest<RefundAppResponse>
    {
        public long RefunderId { get; }
        public string StoreCode { get; }
        public string OriginalPxTradeNo { get; }
        public decimal Amount { get; }
        public decimal NoneFeedbackAmount { get; }
        public decimal NoneDiscountAmount { get; }
        public IEnumerable<ActivityCashDiscountInfo> ActivityCashDiscountInfos { get; }
        public string MerchantTradeNo { get; }
        public string RefundCause { get; }
        public int ExecuteSource { get; }
        public string Executor { get;  }

        public RefundCommand(long refunderId, string storeCode, string originalPxTradeNo, decimal amount, decimal noneFeedbackAmount, decimal noneDiscountAmount, IEnumerable<ActivityCashDiscountInfo> activityCashDiscountInfos
        ,string merchantTradeNo
        ,string refundCause,int executeSource,string executor)
        {
            RefunderId = refunderId;
            StoreCode = storeCode;
            OriginalPxTradeNo = originalPxTradeNo;
            Amount = amount;
            NoneFeedbackAmount = noneFeedbackAmount;
            NoneDiscountAmount = noneDiscountAmount;
            ActivityCashDiscountInfos = activityCashDiscountInfos;
            MerchantTradeNo = merchantTradeNo;
            RefundCause = refundCause;
            ExecuteSource = executeSource;
            Executor = executor;
        }
    }
}