using System.Threading;
using System.Threading.Tasks;
using MediatR;
using Microsoft.Extensions.Logging;
using PXPlus.Payment.Domain.Events;

namespace PXPlus.Payment.Application.DomainEventHandlers.OrderPaymentCanceled
{
    public class OrderPaymentCanceledDomainEventHandler : INotificationHandler<OrderPaymentCanceledDomainEvent>
    {
        private readonly ILogger<OrderPaymentCanceledDomainEventHandler> _logger;

        public OrderPaymentCanceledDomainEventHandler(ILogger<OrderPaymentCanceledDomainEventHandler> logger)
        {
            _logger = logger;
        }
        
        public async Task Handle(OrderPaymentCanceledDomainEvent notification, CancellationToken cancellationToken)
        {
            _logger.LogInformation("{@OrderNo} Payment Canceled",notification.Order.OrderNo);

            //rollback any action // like return point and return account
            
            
        }
    }
}