// using System;
// using System.Collections.Generic;
// using System.Linq;
// using System.Text.Json;
// using System.Threading.Tasks;
// using Confluent.Kafka;
// using Microsoft.Extensions.Logging;
// using PXPlus.Payment.Application.IntegrationEvents;
//
// namespace PXPlus.Payment.Application.EventBus
// {
//     public class KafkaEventBus : IEventBus
//     {
//
//         private readonly IProducer<Null, string> _producer;
//         private readonly Dictionary<Type, string> _integrationEventAndTopicName;
//         private readonly ILogger<KafkaEventBus> _logger;
//         public KafkaEventBus(IProducer<Null, string> producer,ILogger<KafkaEventBus> logger)
//         {
//             _producer = producer;
//             _integrationEventAndTopicName = new Dictionary<Type, string>();
//             _logger = logger;
//         }
//         
//         public async Task PublishAsync(IntegrationEvent @event)
//         {
//             
//             var message = new Message<Null, string>
//                           {
//                               Value = JsonSerializer.Serialize(@event,@event.GetType()) 
//                           };
//             
//             
//             if (! _integrationEventAndTopicName.TryGetValue(@event.GetType(), out var topic))
//             {
//                 topic = GetTopicName(@event);
//                 _integrationEventAndTopicName.Add(@event.GetType(),topic);
//             }
//             
//             _logger.LogInformation("Send event {@Event} to topic {@Topic} ..",@event,topic);
//             
//             await _producer.ProduceAsync(topic, message);
//         }
//
//         private string GetTopicName(IntegrationEvent @event)
//         {
//             var name = @event.GetType().FullName?.Split('.').LastOrDefault()?.Replace("IntegrationEvent","");
//             if (name == null)
//                 throw new InvalidOperationException($"{@event.GetType().FullName} is null. Must be xxxIntegrationEvent");
//             
//             //OrderPaymentSuccessful => order_payment_successful
//             return string.Concat(name.Select((x,i) => i > 0 && char.IsUpper(x) ? "_" + x : x.ToString())).ToLower();
//         }
//     }
// }