﻿using System;
using System.Collections.Generic;
using PXPlus.Payment.Domain.OrderAggregate;

namespace PXPlus.Payment.Application.IntegrationEvents.Events
{
    public interface IOrderPaymentIntegrationEvent
    {
        public string OrderNo { get; set; }
        public decimal OrderAmount { get; set; }
        public decimal PayAmount { get; set; }
        public decimal CashBack { get; set; }
        public decimal PointBack { get; set; }
        public long PayerId { get; set; }
        public string PayerPaymentAccount { get; set; }
        public int PayerPayToolType { get; set; }
        public long StoreMemberId { get; set; }
        public string MerchantCode { get; set; }
        public string MerchantName { get; set; }
        public string StoreCode { get; set; }
        public string StoreName { get; set; }
        public string StoreReceiveAccount { get; set; }
        public decimal ActualDiscountAmount { get; set; }
        public DateTime TransactionTime { get; set; }
        public string MerchantTradeNo { get; set; }
        public CurrencyType CurrencyType { get; set; }
        public string PhoneNumber { get; set; }
        public string BrandName { get; set; }
        public MetaData InputMetaData { get; set; }
        public MetaData ReceiveMetaData { get; set; }
        public string BankCode { get; set; }
        public string BankName { get; set; }
        public string BankReturnCode { get; set; }
        public string Note { get; set; }
        public string PayerEpAccount { get; set; }
        public IEnumerable<Fee> Fees { get; set; }
    }
}