using System;
using PXPlus.Payment.Domain.OrderAggregate;

namespace PXPlus.Payment.Application.IntegrationEvents.Events
{
    public interface IOrderRefundIntegrationEvent
    {
        public string OrderNo { get; set; }
        public string RefundOrderNo { get; set; }
        /// <summary>
        /// 退款金額
        /// </summary>
        public decimal OrderAmount { get; set; }
        /// <summary>
        /// 退還消費者金額
        /// </summary>
        public decimal PayAmount { get; set; }

        /// <summary>
        /// 回饋扣回現金 
        /// </summary>
        public decimal CashBack { get; set; }
        /// <summary>
        /// 回饋扣回點數
        /// </summary>
        public decimal PointBack { get; set; }
        public long PayerId { get; set; }
        public string PayerPaymentAccount { get; set; }
        public int PayerPayToolType { get; set; }
        public string MerchantCode { get; set; }
        public string StoreCode { get; set; }
        public long StoreMemberId { get; set; }
        public string StoreReceiveAccount { get; set; }
        /// <summary>
        /// 退還消費者點數
        /// </summary>
        public decimal ReturnDiscountPointAmount { get; set; }
        public DateTime TransactionTime { get; set; }
        public string RefundCause { get; set; }
        public int ExecuteSource { get; set; }
        public string Executor { get; set; }

        public string MerchantTradeNo { get; set; }
        public string PhoneNumber { get; set; }
        public string BrandName { get; set; }
        public string MerchantName { get; set; }
        public string StoreName { get; set; }
        public CurrencyType CurrencyType { get; set; }
        public string BankCode { get; set; }
        public string BankName { get; set; }
    }
}