﻿using PXPlus.Core.EventBus.Events;

namespace PXPlus.Payment.Application.IntegrationEvents.Events
{
    public record PaymentRecordIntegrationEvent : IntegrationEvent
    {
        /// <summary>
        /// 1 = Payment Service
        /// </summary>
        public int EventType { get; set; }
        public PaymentServiceForPaymentRecord PaymentService { get; set; }

        public PaymentRecordIntegrationEvent(IntegrationEvent integrationEvent,long payerId,string xRequestId) 
            : base(xRequestId,payerId.ToString())
        {
            EventType = 1; 
            PaymentService = new PaymentServiceForPaymentRecord();
            switch (integrationEvent)
            {
                case OrderPaymentSuccessfulIntegrationEvent orderPaymentSuccessfulIntegrationEvent:
                    PaymentService.PaymentType = 1;
                    PaymentService.IsSuccess = true;
                    PaymentService.OrderPaymentSuccessfulIntegrationEvent = orderPaymentSuccessfulIntegrationEvent;
                    break;
                case OrderPaymentFailedIntegrationEvent orderPaymentFailedIntegrationEvent:
                    PaymentService.PaymentType = 1;
                    PaymentService.IsSuccess = false;
                    PaymentService.OrderPaymentFailedIntegrationEvent = orderPaymentFailedIntegrationEvent;
                    break;
                case OrderRefundSuccessfulIntegrationEvent orderRefundSuccessfulIntegrationEvent:
                    PaymentService.PaymentType = 2;
                    PaymentService.IsSuccess = true;
                    PaymentService.OrderRefundSuccessfulIntegrationEvent = orderRefundSuccessfulIntegrationEvent;
                    break;
                case OrderRefundFailedIntegrationEvent orderRefundFailedIntegrationEvent:
                    PaymentService.PaymentType = 2;
                    PaymentService.IsSuccess = false;
                    PaymentService.OrderRefundFailedIntegrationEvent = orderRefundFailedIntegrationEvent;
                    break;
            }
        }
        
          
        // for JsonConstructor
        public PaymentRecordIntegrationEvent()
        {
            
        }
    }

    public class PaymentServiceForPaymentRecord
    {
        /// <summary>
        ///  1 = Payment , 2 = Refund
        /// </summary>
        public int PaymentType { get; set; }
        public bool IsSuccess { get; set; }
        public OrderPaymentSuccessfulIntegrationEvent OrderPaymentSuccessfulIntegrationEvent { get; set; }
        public OrderPaymentFailedIntegrationEvent OrderPaymentFailedIntegrationEvent { get; set; }
        public OrderRefundSuccessfulIntegrationEvent OrderRefundSuccessfulIntegrationEvent { get; set; }
        public OrderRefundFailedIntegrationEvent OrderRefundFailedIntegrationEvent { get; set; }
    }
}