﻿using FluentValidation;
using PXPlus.Payment.Application.Commands;

namespace PXPlus.Payment.Application.Validations
{
    public class CancelPaymentWithPxTradeNoCommandValidator : AbstractValidator<CancelPaymentWithPxTradeNoCommand>
    {
        public CancelPaymentWithPxTradeNoCommandValidator()
        {
            RuleFor(c => c.PxTradeNo).NotEmpty();
            RuleFor(c => c.PayerId).NotEmpty().GreaterThan(0);
            RuleFor(c => c.StoreCode).NotEmpty();
        }
    }
}