﻿using FluentValidation;
using PXPlus.Payment.Application.Commands;

namespace PXPlus.Payment.Application.Validations
{
    public class OrderConfirmCommandValidator : AbstractValidator<OrderConfirmCommand>
    {
        public OrderConfirmCommandValidator()
        {
            RuleFor(c => c.PXTradeNo).NotEmpty();
            RuleFor(c => c.PayerId).NotEmpty().GreaterThan(0);
            RuleFor(c => c.StoreCode).NotEmpty();
        }
    }
}