using FluentValidation;
using Microsoft.Extensions.Logging;
using PXPlus.Payment.Application.Commands;

namespace PXPlus.Payment.Application.Validations
{
    public class PaymentCommandValidator : AbstractValidator<PaymentCommand>
    {
        public PaymentCommandValidator()
        {
            
        }
        public PaymentCommandValidator(ILogger<PaymentCommandValidator> logger)
        {
            RuleFor(c => c.PayerId).NotEmpty().GreaterThan(0);
            RuleFor(c => c.PayToolType).IsInEnum();
            RuleFor(c => c.Sequence).GreaterThanOrEqualTo(0);
            RuleFor(c => c.OrderAmount).NotEmpty().GreaterThan(decimal.Zero);
            RuleFor(c => c.StoreCode).NotEmpty();
            RuleFor(c => c.NoneDiscountAmount).GreaterThanOrEqualTo(decimal.Zero);
            RuleFor(c => c.NoneFeedbackAmount).GreaterThanOrEqualTo(decimal.Zero);
            
            logger.LogTrace("----- INSTANCE CREATED - {ClassName}", GetType().Name);
        }
    }
}