using FluentValidation;
using PXPlus.Payment.Application.Commands;

namespace PXPlus.Payment.Application.Validations
{
    public class RefundCommandValidator : AbstractValidator<RefundCommand>
    {
        public RefundCommandValidator()
        {
            RuleFor(c => c.OriginalPxTradeNo).NotEmpty();
            RuleFor(c => c.RefunderId).NotEmpty().GreaterThan(0);
            RuleFor(c => c.StoreCode).NotEmpty();
            RuleFor(c => c.Amount).NotEmpty().GreaterThan(decimal.Zero);
        }
    }
}