using PXPlus.Enum.Bank;
using PXPlus.Payment.Domain.OrderAggregate.PayTools;
using Xunit;

namespace PXPlus.Payment.Domain.Test.OrderAggregateTest
{
    public class PayToolTest
    {
        [Fact]
        public void MaskCreditCardNo()
        {
            var creditCardNo = "1234567890123456";
            var expiryDate = "202105";
            var target = new CreditCardPayTool(creditCardNo,expiryDate,null,"0",null);

            var result = target.GetMaskedPayToolAccount();
            
            Assert.Equal("123456******3456",result);
            Assert.Equal(creditCardNo,target.CreditCard);
            Assert.Equal("2105",target.ExpiryDate);
        }
        
        [Fact]
        public void MaskAccountOfAccountLink()
        {
            var account = "1234567890123456";
            
            var target = new AccountLinkPayTool(account,null,null,null,"001",null);

            var result = target.GetMaskedPayToolAccount();
            
            Assert.Equal("***********23456",result);
            Assert.Equal(account,target.VirtualAccount);
        }   
        
        [Fact]
        public void MaskAccountOfEpAccount()
        {
            var account = "1234567890123456";
            
            var target = new EpAccountPayTool(account);

            var result = target.GetMaskedPayToolAccount();
            
            Assert.Equal("************3456",result);
            Assert.Equal(account,target.EpAccount);
        }   
    }
}