using PXPlus.Payment.Domain.OrderAggregate;
using Xunit;

namespace PXPlus.Payment.Domain.Test.OrderAggregateTest.PointDiscountInfoValueObject
{
    public class PointDiscountInfoCalculateActualDiscountTest
    {
        private PointDiscountInfo GetTarget(decimal discountPercent)
            => new PointDiscountInfo(discountPercent, true);

        
        /// <summary>
        /// 可折抵 30% 訂單金額 100 實際扣 0 -> 實際扣 = 0
        /// </summary>
        [Fact]
        public void AvailableDiscountPercent30_OrderAmount100_ActualDiscount0_Than_ActualDiscountIs0()
        {
            var pointDiscountInfo = GetTarget(30);
            
            pointDiscountInfo.CalculateAvailableDiscount(100);
            
            pointDiscountInfo.CalculateActualDiscountAmount(0);

            Assert.Equal(0,pointDiscountInfo.ActualDiscountAmount);
        }
        
        
        /// <summary>
        /// 可折抵 30% 訂單金額 100 實際扣 31 -> 實際扣 = 30
        /// </summary>
        [Fact]
        public void AvailableDiscountPercent30_OrderAmount100_ActualDiscount31_Than_ActualDiscountIs30()
        {
            var pointDiscountInfo = GetTarget(30);
            
            pointDiscountInfo.CalculateAvailableDiscount(100);
            
            pointDiscountInfo.CalculateActualDiscountAmount(31);

            Assert.Equal(30,pointDiscountInfo.ActualDiscountAmount);
        }
        
        
        /// <summary>
        /// 可折抵 30% 訂單金額 100 實際扣 30 -> 實際扣 = 30
        /// </summary>
        [Fact]
        public void AvailableDiscountPercent30_OrderAmount100_ActualDiscount30_Than_ActualDiscountIs30()
        {
            var pointDiscountInfo =GetTarget(30);
            
            pointDiscountInfo.CalculateAvailableDiscount(100);
            
            pointDiscountInfo.CalculateActualDiscountAmount(30);

            Assert.Equal(30,pointDiscountInfo.ActualDiscountAmount);
        }
    }
}