using PXPlus.Payment.Domain.OrderAggregate;
using Xunit;

namespace PXPlus.Payment.Domain.Test.OrderAggregateTest.PointDiscountInfoValueObject
{
    public class PointDiscountInfoCalculateAvailableDiscountTest
    {
        private PointDiscountInfo GetTarget(decimal discountPercent)
            => new PointDiscountInfo(discountPercent, true);
        
        /// <summary>
        /// 120 * 0.27 = 32.4 四捨五入 = 32
        /// </summary>
        [Fact]
        public void OneHundredTwenty_Multiply_ZeroPointTwentySeven_Rounding_ToThirtyTwo()
        {
            var pointDiscountInfo = GetTarget(27);
            
            pointDiscountInfo.CalculateAvailableDiscount(120);
            
            Assert.Equal(32,pointDiscountInfo.AvailableDiscountAmount);
        }
        
        /// <summary>
        /// 121 * 0.27 = 32.67 四捨五入 = 33
        /// </summary>
        [Fact]
        public void OneHundredTwentyOne_Multiply_ZeroPointTwentySeven_RoundingTo_ThirtyThree()
        {
            var pointDiscountInfo = GetTarget(27);
            
            pointDiscountInfo.CalculateAvailableDiscount(121);

            Assert.Equal(33,pointDiscountInfo.AvailableDiscountAmount);
        }
    }
}