using System;
using PXPlus.Payment.Domain.OrderAggregate;
using Xunit;

namespace PXPlus.Payment.Domain.Test.OrderAggregateTest.PointDiscountInfoValueObject
{
    public class PointDiscountInfoExceptionTest
    {
              
        private PointDiscountInfo GetTarget(decimal discountPercent)
            => new PointDiscountInfo(discountPercent, true);
        
        [Fact]
        public void If_PointDiscountPercent_LessThenZero_Than_ThrowException()
        {
            Assert.Throws<ArgumentOutOfRangeException>(()=>GetTarget(-1));
        }

        [Fact]
        public void If_AvailableDiscountAmount_LessThenZero_Than_ThrowException()
        {
            var pointDiscountInfo = GetTarget(30);

            Assert.Throws<ArgumentOutOfRangeException>(() => pointDiscountInfo.CalculateAvailableDiscount(-1));
        }

        [Fact]
        public void If_ActualDiscountAmount_LessThenZero_Than_TrowException()
        {
            var pointDiscountInfo = GetTarget(30);

            Assert.Throws<ArgumentOutOfRangeException>(() => pointDiscountInfo.CalculateActualDiscountAmount(-1));
        }
    }
}