﻿using System.Threading.Tasks;
using PXPlus.Payment.Domain.OrderAggregate;
using PXPlus.Payment.Domain.OrderAggregate.PayTools;

namespace PXPlus.Payment.Domain.DomainServices.Interface
{
    public interface IExecutePaymentDomainService
    {
        Task<ExecutePaymentInfo> PaymentAsync(string pxTradeNo,
            decimal payAmount,
            IPayTool payTool,
            ReceiveStoreInfo storeInfo);

        Task<ExecuteRefundInfo> RefundAsync(string pxOriTradeNo, string pxRefundTradeNo, decimal payAmount,
            PayerInfo payerInfo, ReceiveStoreInfo storeInfo);

    }


    public class ExecutePaymentInfo
    {
        public bool IsSuccess { get; set; }
        public string Message { get; set; }
        public string Code { get; set; }
        public string BankReturnCode { get; set; }
    }

    public class ExecuteRefundInfo
    {
        public bool IsSuccess { get; set; }
        public string Message { get; set; }
        public string Code { get; set; }
        public string BankReturnCode { get; set; }
    }
}