using System.Text;

namespace PXPlus.Payment.Domain.OrderAggregate.PayTools
{
    public record AccountLinkPayTool : IPayTool
    {
        public string VirtualAccount { get; }
        public string EPAccount { get; }
        /// <summary>
        /// 身分證字號
        /// </summary>
        public string IdentityNo { get; }
        public string BankName { get; }
        public string BankCode { get; }
        public string NickName { get; }
  
        public AccountLinkPayTool(string virtualAccount, string epAccount, string identityNo, string bankName, string bankCode, string nickName)
        {
            VirtualAccount = virtualAccount;
            EPAccount = epAccount;
            IdentityNo = identityNo;
            BankName = bankName;
            BankCode = bankCode;
            NickName = nickName;
        }

        public string GetPaymentAccount()
            => VirtualAccount;

        public string GetMaskedPayToolAccount()
        {
            var length = VirtualAccount.Length;
            var lastFive = VirtualAccount.Remove(0, length - 5);
            
            var stringBuilder = new StringBuilder();
            for (int i = 0; i < VirtualAccount.Length - 5; i++)
                stringBuilder.Append("*");
            
            stringBuilder.Append(lastFive);
            return stringBuilder.ToString();
        }

        public string GetPayToolName()
            => BankName;
    }
}