namespace PXPlus.Payment.Domain.OrderAggregate.PayTools
{
    public record CreditCardPayTool : IPayTool
    {
        public string CreditCard { get; }
        public string ExpiryDate { get; }
        public string BankName { get; }
        public string BankCode { get; }
        public string NickName { get; }

        public CreditCardPayTool(string creditCard, string expiryDate, string bankName, string bankCode, string nickName)
        {
            CreditCard= creditCard;
            // ExpiryDate from EpAccount is yyyyMM , but creditcard service need yyMM.
            ExpiryDate = expiryDate.Length == 6 ? expiryDate[2..6] : expiryDate;
            BankName = bankName;
            BankCode = bankCode;
            NickName = nickName;
        }

        public string GetPaymentAccount()
            => CreditCard;

        public string GetMaskedPayToolAccount()
            => CreditCard.Remove(6, 6).Insert(6,"******");
          
        public string GetPayToolName()
            => BankName;
    }
    
    
}