using System.Text;

namespace PXPlus.Payment.Domain.OrderAggregate.PayTools
{
    public record EpAccountPayTool : IPayTool
    {
        private const string PayToolName = "全支付帳戶";
        public string EpAccount { get; }
        public string BankName { get; }
        public string BankCode { get; }

        public EpAccountPayTool(string epAccount)
        {
            EpAccount= epAccount;
        }

        public string GetPaymentAccount()
            => EpAccount;

        public string GetMaskedPayToolAccount()
        {
            if (string.IsNullOrEmpty(EpAccount))
                return string.Empty;
            
            var length = EpAccount.Length;
            var lastFour = EpAccount.Remove(0, length - 4);
            
            var stringBuilder = new StringBuilder();
            for (int i = 0; i < EpAccount.Length - 4; i++)
                stringBuilder.Append("*");
            
            stringBuilder.Append(lastFour);
            return stringBuilder.ToString();
        }

        public string GetPayToolName()
            => PayToolName;

   
    }
}