﻿using System;

namespace PXPlus.Payment.Domain.PaymentQuotaAggregate
{
    public record PaymentQuota
    {
        /// <summary>
        /// 當天已使用額度
        /// </summary>
        public decimal DailyQuota { get; }
        /// <summary>
        /// 當月已使用額度
        /// </summary>
        public decimal MonthlyQuota { get; }

        public PaymentQuota(decimal dailyQuota, decimal monthlyQuota)
        {
            if (dailyQuota < decimal.Zero || monthlyQuota < decimal.Zero)
                throw new ArgumentOutOfRangeException();
            
            DailyQuota = dailyQuota;
            MonthlyQuota = monthlyQuota;
        }
    }
}