using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using PXPlus.Payment.Domain.DomainServices;
using PXPlus.Payment.Domain.DomainServices.Interface;
using PXPlus.Payment.Domain.OrderAggregate;

namespace PXPlus.Payment.Infrastructure.DomainServiceGrpc
{
    public class ActivityMockDomainService : IActivityDomainService
    {
        public async Task<IEnumerable<ActivityFeedbackInfo>> CalculateActivitiesFeedbackAsync(long payerId)
        {
            var random = new Random();

            return new List<ActivityFeedbackInfo>
                   {
                       new()
                       {
                           ActivityId = Guid.NewGuid().ToString(),
                           CashFeedback = random.Next(1, 25),
                           PointFeedback = random.Next(1, 25)
                       },
                       new()
                       {
                           ActivityId = Guid.NewGuid().ToString(),
                           CashFeedback = random.Next(1, 25),
                           PointFeedback = random.Next(1, 25)
                       },
                       new()
                       {
                           ActivityId = Guid.NewGuid().ToString(),
                           CashFeedback = random.Next(1, 25),
                           PointFeedback = random.Next(1, 25)
                       }
                   };
        }

        public async Task<IEnumerable<ActivityCashDiscountInfo>> CalculateActivitiesCashDiscountAsync(
            IEnumerable<ActivityCashDiscountInfo> discountInfos)
        {
            return discountInfos.ToList();
        }
    }
}