using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Metadata.Builders;
using PXPlus.Payment.Infrastructure.Idempotency;

namespace PXPlus.Payment.Infrastructure.EntityConfigurations
{
    public class ClientRequestEntityTypeConfiguration : IEntityTypeConfiguration<ClientRequest>
    {
        public void Configure(EntityTypeBuilder<ClientRequest> builder)
        {
            builder.ToTable("requests");
            
            builder.HasKey(c => c.Id);

            builder.HasIndex(c=>c.TradeNo)
                    .IsUnique();
                
            builder.Property(c => c.TradeNo)
                    .HasColumnType("varchar(60)");

            builder.Property(c => c.Time)
                    .HasColumnType("datetime2");
    
            builder.Property(c => c.ClientRequestType)
                   .HasColumnType("smallint");
        }
    }
}