﻿using PaymentService;
using PXPlus.Payment.Api.Services;
using PXPlus.Payment.Application.Commands;
using Xunit;

namespace PXPlus.Payment.Api.Test.GrpcServiceMapTest
{
    public class OrderConfirmGrpcTest
    {
        private readonly ConfirmOrderGrpcServiceTest _target;

        public OrderConfirmGrpcTest()
        {
            _target = new ConfirmOrderGrpcServiceTest();
        }

        [Fact]
        public void OrderConfirmGrpcRequestMapFromOrderConfirmCommand()
        {
            var inputGrpc = new OrderConfirmGrpcRequest
            {
                TradeNo = "F06B77F3-A6E2-43AB-A2A6-CE473A4E7A04",
                PayerId = 785,
                PxTradeNo = "8E405348-3666-4FA7-940F-C2AA8D0A77F5",
                StoreCode = "1C126BFB-646B-4E04-AC70-96CCEB9A1678"
            };

            var excepted = new OrderConfirmCommand(inputGrpc.PxTradeNo,inputGrpc.PayerId,inputGrpc.StoreCode);

            var actual = _target.MapFromTest(inputGrpc);
            
            Assert.Equal(excepted.PayerId,actual.PayerId);
            Assert.Equal(excepted.PXTradeNo,actual.PXTradeNo);
            Assert.Equal(excepted.StoreCode,actual.StoreCode);
        }
    }

    public class ConfirmOrderGrpcServiceTest :ConfirmOrderGrpcService
    {
        public ConfirmOrderGrpcServiceTest() : base(null,null)
        {
        }

        public OrderConfirmCommand MapFromTest(OrderConfirmGrpcRequest request)
        {
            return MapFrom(request);
        }
    }
}