﻿using System;
using Microsoft.EntityFrameworkCore.Migrations;

namespace PXPlus.Payment.Api.Infrastructure.IntegrationEventMigrations
{
    public partial class initial : Migration
    {
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.CreateTable(
                name: "IntegrationEventLog",
                columns: table => new
                {
                    Id = table.Column<int>(type: "int", nullable: false)
                        .Annotation("SqlServer:Identity", "1, 1"),
                    EventId = table.Column<string>(type: "char(36)", nullable: false),
                    EventTypeName = table.Column<string>(type: "nvarchar(max)", nullable: false),
                    State = table.Column<short>(type: "smallint", nullable: false),
                    TimesSent = table.Column<int>(type: "int", nullable: false),
                    CreationTime = table.Column<DateTime>(type: "datetime2", nullable: false),
                    Content = table.Column<string>(type: "nvarchar(max)", nullable: false),
                    TransactionId = table.Column<string>(type: "char(36)", nullable: false),
                    XRequestId = table.Column<string>(type: "varchar(120)", nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_IntegrationEventLog", x => x.Id);
                });

            migrationBuilder.CreateIndex(
                name: "IX_IntegrationEventLog_State",
                table: "IntegrationEventLog",
                column: "State");

            migrationBuilder.CreateIndex(
                name: "IX_IntegrationEventLog_TransactionId",
                table: "IntegrationEventLog",
                column: "TransactionId");

            migrationBuilder.CreateIndex(
                name: "IX_IntegrationEventLog_XRequestId",
                table: "IntegrationEventLog",
                column: "XRequestId");
        }

        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropTable(
                name: "IntegrationEventLog");
        }
    }
}
