using System.Linq;
using PaymentService;
using PXPlus.Payment.Application.Dto;

namespace PXPlus.Payment.Api.Infrastructure.Mapper
{
    public class RefundAppResMapToGrpcRes
    {
        public RefundGrpcResponse MapTo(RefundAppResponse response)
        {
            var grpcResponse =
                new RefundGrpcResponse
                {
                    Code = response.Code ?? "",
                    Message = response.Message ?? "",
                    PrefixCode = response.Prefix ?? "",
                    Data = new RefundInfo
                           {
                               PxTradeNo = response.PXTradeNo ?? "",
                               Amount = (double) response.Amount,
                               TradeAmount = (double) response.TradeAmount,
                               DiscountPoint = (double) response.DiscountPoint
                           }
                };

            if (response.Activities != null && response.Activities.Any())
                grpcResponse.Data.Activities.AddRange(response.Activities.Select(s => new ActivityDiscount
                        {
                            ActivityCode = s.ActivityCode,
                            ProductAmount = s.ProductAmount,
                            DiscountAmount = s.DiscountAmount,
                        })
                );
            
            return grpcResponse;
        }
    }
}