﻿using System;
using Microsoft.EntityFrameworkCore.Migrations;

namespace PXPlus.Payment.Api.Infrastructure.Migrations
{
    public partial class initial : Migration
    {
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.CreateTable(
                name: "OrderRecords",
                columns: table => new
                {
                    Id = table.Column<long>(type: "bigint", nullable: false)
                        .Annotation("SqlServer:Identity", "1, 1"),
                    OrderId = table.Column<long>(type: "bigint", nullable: false),
                    OrderNo = table.Column<string>(type: "varchar(25)", nullable: true),
                    OrderRecordType = table.Column<short>(type: "smallint", nullable: false),
                    OrderRecordResult = table.Column<short>(type: "smallint", nullable: false),
                    RecordTime = table.Column<DateTime>(type: "datetime2", nullable: false),
                    OrderTime = table.Column<DateTime>(type: "datetime2", nullable: false),
                    OrderAmount = table.Column<decimal>(type: "decimal(18,2)", precision: 18, scale: 2, nullable: false),
                    PayAmount = table.Column<decimal>(type: "decimal(18,2)", precision: 18, scale: 2, nullable: false),
                    ActualDiscountAmount = table.Column<decimal>(type: "decimal(18,2)", precision: 18, scale: 2, nullable: false),
                    NoneDiscountAmount = table.Column<decimal>(type: "decimal(18,2)", precision: 18, scale: 2, nullable: false),
                    ActivityCashDiscountInfos = table.Column<string>(type: "varchar(max)", nullable: true),
                    ActivityFeedbackInfos = table.Column<string>(type: "varchar(max)", nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_OrderRecords", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "Orders",
                columns: table => new
                {
                    Id = table.Column<long>(type: "bigint", nullable: false)
                        .Annotation("SqlServer:Identity", "1, 1"),
                    OrderNo = table.Column<string>(type: "varchar(20)", nullable: true),
                    RefundOrderNo = table.Column<string>(type: "varchar(25)", nullable: true),
                    OrderAmount = table.Column<decimal>(type: "decimal(18,2)", precision: 18, scale: 2, nullable: false),
                    PayAmount = table.Column<decimal>(type: "decimal(18,2)", precision: 18, scale: 2, nullable: false),
                    NoneDiscountAmount = table.Column<decimal>(type: "decimal(18,2)", precision: 18, scale: 2, nullable: false),
                    NoneFeedbackAmount = table.Column<decimal>(type: "decimal(18,2)", precision: 18, scale: 2, nullable: false),
                    OrderStatus = table.Column<int>(type: "int", nullable: false),
                    PayerId = table.Column<long>(type: "bigint", nullable: true),
                    PayToolType = table.Column<short>(type: "smallint", nullable: true),
                    PayerAccount = table.Column<string>(type: "varchar(50)", nullable: true),
                    Sequence = table.Column<short>(type: "smallint", nullable: true),
                    AccountLinkPayTool = table.Column<string>(type: "varchar(max)", nullable: true),
                    CreditCardPayTool = table.Column<string>(type: "varchar(max)", nullable: true),
                    EpAccountPayTool = table.Column<string>(type: "varchar(max)", nullable: true),
                    MerchantName = table.Column<string>(type: "nvarchar(max)", nullable: true),
                    ReceiveStoreInfo_MerchantName = table.Column<string>(type: "nvarchar(max)", nullable: true),
                    StoreCode = table.Column<string>(type: "varchar(max)", nullable: true),
                    StoreName = table.Column<string>(type: "nvarchar(max)", nullable: true),
                    StoreMemberId = table.Column<long>(type: "bigint", nullable: true),
                    ReceiveAccount = table.Column<string>(type: "varchar(50)", nullable: true),
                    TradeFeeAmount = table.Column<decimal>(type: "decimal(18,2)", precision: 18, scale: 2, nullable: true),
                    TradeFeeUnit = table.Column<byte>(type: "tinyint", nullable: true),
                    ReceiveStoreInfo_PointDiscountFeeRate = table.Column<decimal>(type: "decimal(18,2)", precision: 18, scale: 2, nullable: true),
                    ReceiveStoreInfo_PointDiscountPercent = table.Column<decimal>(type: "decimal(18,2)", precision: 18, scale: 2, nullable: true),
                    IndustryType = table.Column<short>(type: "smallint", nullable: true),
                    IsUsePoint = table.Column<byte>(type: "tinyint", nullable: true),
                    DiscountPercent = table.Column<decimal>(type: "decimal(18,2)", precision: 18, scale: 2, nullable: true),
                    AvailableDiscountAmount = table.Column<decimal>(type: "decimal(18,2)", precision: 18, scale: 2, nullable: true),
                    ActualDiscountAmount = table.Column<decimal>(type: "decimal(18,2)", precision: 18, scale: 2, nullable: true),
                    RefundCount = table.Column<int>(type: "int", nullable: false),
                    PlatformType = table.Column<byte>(type: "tinyint", nullable: false),
                    ActivityCashDiscountInfos = table.Column<string>(type: "varchar(max)", nullable: true),
                    ActivityFeedbackInfos = table.Column<string>(type: "varchar(max)", nullable: true),
                    CreatedTime = table.Column<DateTime>(type: "DateTime", nullable: false),
                    UpdatedTime = table.Column<DateTime>(type: "DateTime", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Orders", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "requests",
                columns: table => new
                {
                    TradeNo = table.Column<string>(type: "nvarchar(450)", nullable: false),
                    Time = table.Column<DateTime>(type: "datetime2", nullable: false),
                    ResponseData = table.Column<string>(type: "nvarchar(max)", nullable: true),
                    ClientRequestType = table.Column<short>(type: "smallint", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_requests", x => x.TradeNo);
                });

            migrationBuilder.CreateIndex(
                name: "IX_OrderRecords_OrderId",
                table: "OrderRecords",
                column: "OrderId");

            migrationBuilder.CreateIndex(
                name: "IX_OrderRecords_OrderNo",
                table: "OrderRecords",
                column: "OrderNo");

            migrationBuilder.CreateIndex(
                name: "IX_Orders_OrderNo",
                table: "Orders",
                column: "OrderNo");
        }

        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropTable(
                name: "OrderRecords");

            migrationBuilder.DropTable(
                name: "Orders");

            migrationBuilder.DropTable(
                name: "requests");
        }
    }
}
