﻿using CorrelationId.Abstractions;
using Grpc.Core;
using Grpc.Core.Interceptors;

namespace PXPlus.PaymentCancel.Worker.Interceptors
{
    public class WorkerRequestIdInterceptor : Interceptor
    {
        private readonly ICorrelationContextAccessor _correlationContextAccessor;

        public WorkerRequestIdInterceptor(ICorrelationContextAccessor correlationContextAccessor)
        {
            _correlationContextAccessor = correlationContextAccessor;
        }
        
        public override AsyncUnaryCall<TResponse> AsyncUnaryCall<TRequest, TResponse>(TRequest request, ClientInterceptorContext<TRequest, TResponse> context,
            AsyncUnaryCallContinuation<TRequest, TResponse> continuation)

        {
            var correlationContext = _correlationContextAccessor.CorrelationContext;
            var headers = new Metadata()
            {
                new Metadata.Entry(correlationContext.Header, correlationContext.CorrelationId)
            };
            var options = context.Options.WithHeaders(headers);
            context = new ClientInterceptorContext<TRequest, TResponse>(context.Method, context.Host, options);
            return base.AsyncUnaryCall(request, context, continuation);

        }
    }
}