﻿using System;
using System.Threading.Tasks;
using Microsoft.Extensions.Logging;
using PaymentService;

namespace PXPlus.PaymentCancel.Worker.Payment
{
    public class QueryService : IQueryService
    {
        private readonly QueryGrpcService.QueryGrpcServiceClient _queryGrpcServiceClient;
        private readonly ILogger<QueryService> _logger;

        public QueryService(QueryGrpcService.QueryGrpcServiceClient queryGrpcServiceClient, ILogger<QueryService> logger)
        {
            _queryGrpcServiceClient = queryGrpcServiceClient;
            _logger = logger;
        }
        
        public async Task<QueryGrpcResponse> QueryAsync(QueryGrpcRequest request)
        {
            try
            {
                return await _queryGrpcServiceClient.QueryAsync(request);
            }
            catch (Exception e)
            {
                _logger.LogError(e,e.Message);
                return new QueryGrpcResponse
                {
                    Code = "9999",
                    Message = e.Message
                };
            }
        }
    }
}