﻿using System;
using System.Threading.Tasks;
using Microsoft.Extensions.Logging;
using PaymentService;

namespace PXPlus.PaymentCancel.Worker.Payment
{
    public class RefundService : IRefundService
    {
        private readonly RefundGrpcService.RefundGrpcServiceClient _refundGrpcServiceClient;
        private readonly ILogger<RefundService> _logger;

        public RefundService(RefundGrpcService.RefundGrpcServiceClient refundGrpcServiceClient, ILogger<RefundService> logger)
        {
            _refundGrpcServiceClient = refundGrpcServiceClient;
            _logger = logger;
        }

        public async Task<RefundGrpcResponse> RefundCommandAsync(RefundGrpcRequest request)
        {
            try
            {
                return await _refundGrpcServiceClient.RefundCommandAsync(request);
            }
            catch (Exception e)
            {
                _logger.LogError(e,e.Message);
                return new RefundGrpcResponse
                {
                    Code = "9999",
                    Message = e.Message
                };
            }
        }
    }
}